/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Light
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE Ascenseur 2006/2007
Version : 0.1
Date    : 19/02/2007
Author  : TOUZET / PETITJEAN
Company : Lycee Pierre-Emile MARTIN
Comments: 
Programme PPE Ascenseur
2006 / 2007


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>

// Afficheur LCD
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

// Chargement des librairies
#include <90s8535.h>    // librairie C ATMEL AT90S8535
#include <delay.h>      // Fonction delai
#include <tpavnum.h> 	// Table de transcodage du clavier numrique utilis
#include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
#include <pavenum.h>    // Gestion d'un clavier numrique type PS2
#include <stdio.h>	// Fonctions standard entres / sorties

// Programme d'interruption
interrupt [EXT_INT0] void ext_int0_isr(void)
{
 if 

//interrption INT0  cabler entre la carte SSI et la carte interface I2C


}
 
// Adresse CGRAM de l'afficheur LCD
#define Add_Caract0_CGRAM 0x40             //caractre 0
#define Add_Caract1_CGRAM 0x48		   //caractre 1
#define Add_Caract2_CGRAM 0x50             //caractre 2
#define Add_Caract3_CGRAM 0x58             //caractre 3
#define Add_Caract4_CGRAM 0x60             //caractre 4
#define Add_Caract5_CGRAM 0x68             //caractre 5
#define Add_Caract6_CGRAM 0x70             //caractre 6
#define Add_Caract7_CGRAM 0x78             //caractre 7

// Adresses des Ports I2C
#define AD_BASE_PCF8574		0x40       // base I2C
#define AD_I2C_PORTA		0          // port A
#define AD_I2C_PORTB		1          // port B
#define AD_I2C_PORTC		2	   // port C
#define AD_I2C_PORTD		3          // port D


/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/ 
char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur
char Affiche_LCD                           // faire afficher sur le LCD

// Prototype des fonctions :
void PWM1(unsigned long alpha);
void SP1(rampe accel);
void SP2(rampe decel);
void Ecrire_PCF8574(unsigned char add, unsigned char valeur);

// Caractres personnaliss placs dans la mmoire CGRAM du LCD
const unsigned char caractre..[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};                // @0 CGRAM
const unsigned char caractre..[] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};                // @1 CGRAM
const unsigned char caractre..[] = {0x00, 0x0E, 0x0A, 0x0A, 0x0A, 0x0A, 0x1B, 0x00};    	     	 // @2 CGRAM
const unsigned char caractre..[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00};                // @3 CGRAM
const unsigned char caractre..[] = {0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00};                // @4 CGRAM
const unsigned char caractre..[] = {0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00};                // @5 CGRAM
const unsigned char caractre..[] = {0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00};                // @6 CGRAM
const unsigned char caractre..[] = {0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00};                // @7 CGRAM                


void main(void)
{
/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/
unsigned char etat,i,I,J,OCR1AL,OCR1BL,alpha;
unsigned char PO1,PO2,PO3;
unsigned char PC1,PC2,PC3;
unsigned char AP1,AP2,AP3;
unsigned char AC1,AC2,AC3;
unsigned char VP1,VP2,VP3;
unsigned char EL1,EL2,EL3;
unsigned char LED1,LED2,LED3;
unsigned char DEF;

#define PORTA 0
#define PORTB 1
#define PORTC 2
#define PORTD 3

// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0xFF;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;

// I2C Bus initialisation
i2c_init();

// LCD module initialisation
lcd_init(20);        

// Chargement de la mmoire CGRAM de l'afficheur avec les 
// caractres personaliss
for (i=0;i<8;i++)
lcd_write_byte(Add_Caract0_CGRAM + i, caractre..[i]);
for (i=0;i<8;i++)                                
lcd_write_byte(Add_Caract1_CGRAM + i, caractre..[i]); 
for (i=0;i<8;i++)
lcd_write_byte(Add_Caract2_CGRAM + i, caractre..[i]);
for (i=0;i<8;i++)
lcd_write_byte(Add_Caract3_CGRAM + i, caractre..[i]);
for (i=0;i<8;i++)
lcd_write_byte(Add_Caract4_CGRAM + i, caractre..[i]);
for (i=0;i<8;i++)
lcd_write_byte(Add_Caract5_CGRAM + i, caractre..[i]); 
for (i=0;i<8;i++)
lcd_write_byte(Add_Caract6_CGRAM + i, caractre..[i]);
for (i=0;i<8;i++)
lcd_write_byte(Add_Caract7_CGRAM + i, caractre..[i]);


// Global enable interrupts
#asm("sei")

// initialisation :
//----------------
sprintf(display_buffer_ligne0,"   PPE ascenseur");
sprintf(display_buffer_ligne1,"    2006 / 2007");
sprintf(display_buffer_ligne2,"     Carte SSI");
sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
delay_ms(4000);

//faire descendre la cabine jusqu' l'tage 1 et faire clignoter les leds et afficher..

{
PORTA = Lire_PCF8574(0)
PORTC = Lire_PCF8574(3)

while (((PC1==0)))                         
  {
  sprintf(display_buffer_ligne0,"   Initialisation");
  sprintf(display_buffer_ligne1,"        ----");
  sprintf(display_buffer_ligne2," dplacement de la");
  sprintf(display_buffer_ligne3,"cabine jusqu'au RDC");
  Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
  PWM1(255);
  LED1=1;
  LED2=1;
  LED3=1;
  DEF=1;
  delay_ms(500);
  LED1=0;
  LED2=0;
  LED3=0;
  DEF=0;
  }
PWM1(0);
etat = etage_1;
}

//fin initialisation

while (1)
      {
      switch (etat);
      case etage_1 : EL1 = 1;
                     LED1 = 1;
                     sprintf(display_buffer_ligne0,"Etage 1");
                     sprintf(display_buffer_ligne1,"");
                     sprintf(display_buffer_ligne2,"attente appel");
                     sprintf(display_buffer_ligne3,"porte 1 deverouillee");
                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP2 == 1)||(AC2 == 1));
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
       	  	    {
       	  	    sprintf(display_buffer_ligne0,"etage 2 demand");
       	  	    sprintf(display_buffer_ligne1,"");
       
                    sprintf(display_buffer_ligne2,"fermer la porte !");
       	            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	            etat = MC;
                    while(PO1=1);
                    }
                 }    
       	       	else if  ((AP3 == 1)||(AC3 == 1))
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = ML;
       	           while(PO1=1);
       	           }
                 }
                else etat = etage_1;
                LED1 = 0
      break;
      case etage_2 :  EL2 = 1;
                      LED2 = 1;
                      sprintf(display_buffer_ligne0,"Etage 2");
                      sprintf(display_buffer_ligne1,"");
                      sprintf(display_buffer_ligne2,"attente appel");
                      sprintf(display_buffer_ligne3,"porte 2 deverouillee");
                      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP1 == 1)||(AC1 == 1));
                 {
       	  	   do//crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = DC;
       	           while(PO2=1); 
                   }
                 }
       	       	else if  ((AP3 == 1)||(AC3 == 1))
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = ML;
                   while(PO2=1);
                   }
                 }
       	       	else etat = etage_2;
       	       	LED2 = 0
      break;
      case etage_3 :  EL3 = 1;
                      LED3 = 1;
                      sprintf(display_buffer_ligne0,"etage 3");
                      sprintf(display_buffer_ligne1,"");
                      sprintf(display_buffer_ligne2,"attente appel");
                      sprintf(display_buffer_ligne3,"porte 3 deverouillee");
                      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP1 == 1)||(AC1 == 1));
                 {
       	  	   do//crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = DL; 
                   while(PO3=1);
                   }
                 }
       	       	else if  ((AP2 == 1)||(AC2 == 1))
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 2 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = DC;
       	           while(PO3=1);
                   }
                 }
                 else etat = etage_3
                 LED3 = 0
      break;
      case MC : PWM1(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(500);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC2==0))||((PC3==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC3==1)))                        
                   {
                   etat=etage_3;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break; 	
      case DC : PWM(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(500);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC2==0))||((PC1==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC1==1)))                        
                   {
                   etat=etage_1;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break;
      case ML : PWM(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(1000);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC2==0))||((PC3==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC3==1)))                        
                   {
                   etat=etage_3;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break;
      case DL : PWM(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(1000);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC1==0))||((PC2==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC1==1)))                        
                   {
                   etat=etage_1;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break;

      };

AP1 = (Lire_PCF8574(PORTA)&0b01000000);        // lecture PA6
AP2 = (Lire_PCF8574(PORTA)&0b10000000);        // lecture PA7
AP3 = (Lire_PCF8574(PORTB)&0b00000001);        // lecture PB0
AC1 = (Lire_PCF8574(PORTB)&0b00000010);        // lecture PB1
AC2 = (Lire_PCF8574(PORTB)&0b00000100);        // lecture PB2
AC3 = (Lire_PCF8574(PORTB)&0b00001000);        // lecture PB3
PO1 = (Lire_PCF8574(PORTA)&0b00001000);        // lecture PA3
PO2 = (Lire_PCF8574(PORTA)&0b00010000);        // lecture PA4
PO3 = (Lire_PCF8574(PORTA)&0b00100000);        // lecture PA5
VP1 = (Lire_PCF8574(PORTC)&0b00000001);        // lecture PC0
VP2 = (Lire_PCF8574(PORTC)&0b00000010);        // lecture PC1
VP3 = (Lire_PCF8574(PORTC)&0b00000100);        // lecture PC2
PC1 = (Lire_PCF8574(PORTA)&0b00000001);        // lecture PA0
PC2 = (Lire_PCF8574(PORTA)&0b00000010);        // lecture PA1
PC3 = (Lire_PCF8574(PORTA)&0b00000100);        // lecture PA2

PORTA = (Lire_PCF8574(0));           // lecture du port A
PORTB = (Lire_PCF8574(1));           // Lecture du port B
PORTC = (Lire_PCF8574(2));           // Lecture du port C
EtatPORTD = (Lire_PCF8574(3));       // Lecture du port D
                                        
EtatPORTD=EtatPORTD | 0b00010000;	// LED1 = 1
EtatPORTD=EtatPORTD & 0b11101111;	// LED1 = 0		

EtatPORTD=EtatPORTD | 0b00100000;	// LED2 = 1
EtatPORTD=EtatPORTD & 0b11011111;	// LED2 = 0
                                       
EtatPORTD=EtatPORTD | 0b01000000;	// LED3 = 1
EtatPORTD=EtatPORTD & 0b10111111;	// LED3 = 0

EtatPORTD=EtatPORTD | 0b00000010;	// EL1 = 1
EtatPORTD=EtatPORTD & 0b11111101;	// EL1 = 0

EtatPORTD=EtatPORTD | 0b00000100;	// EL2 = 1
EtatPORTD=EtatPORTD & 0b11111011;	// EL2 = 0

EtatPORTD=EtatPORTD | 0b00001000;	// EL3 = 1
EtatPORTD=EtatPORTD & 0b11110111;	// EL3 = 0

EtatPORTD=EtatPORTD | 0b00000001;	// DEF = 1
EtatPORTD=EtatPORTD & 0b11111110;	// DEF = 0

Ecrire_PCF8574(PORTD,EtatPORTD);

}

//fin du programme principal

// Sous-programmes

void PWM1(unsigned long alpha)
    {
    unsigned short maxi;
    maxi=0x00FF;
    OCR1A=maxi-(((100-alpha) * maxi)/100);
    }

void SP1(rampe accel)
    {
     I=0;
     do
      {
      I=I+1;
      delay_ms(10);
      PWM1(I);
      }
     while (((I<255)));
    }

void SP2(rampe decel)
    {
     J=255;
     do
      {
      J=J-1;
      delay_ms(10);
      PWM1(J);
      }
     while (((J>=50)));
    }
    
unsigned char Lire_PCF8574(unsigned char add)
{
  unsigned char entrees;
  i2c_start();
  i2c_write(0x41 | add << 1);
  entrees = i2c_read(0);
  i2c_stop();
  return entrees;    
} 

void Ecrire_PCF8574(unsigned char add, unsigned char valeur)
{
  i2c_start();
  i2c_write(0x40 | add << 1);
  i2c_write(valeur);
  i2c_stop();
  delay_ms(10);
}        