/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Light
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE Ascenseur 2006/2007
Version : 0.2
Date    : 19/02/2007
Author  : TOUZET / PETITJEAN / MOREUX
Company : Lycee Pierre-Emile MARTIN
Comments: 
Programme PPE Ascenseur
2006 / 2007


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

// Chargement des librairies
#include <90s8535.h>    // librairie C ATMEL AT90S8535
#include <delay.h>      // Fonction delai
//#include <tpavnum.h> 	// Table de transcodage du clavier numrique utilis
#include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
//#include <pavenum.h>    // Gestion d'un clavier numrique type PS2
#include <stdio.h>	// Fonctions standard entres / sorties

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>

// Afficheur LCD
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>
#include <ascl.h>

/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/ 
char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur
unsigned char EL1, EL2, EL3;		   // Etat d

// Programme d'interruption
interrupt [EXT_INT0] void ext_int0_isr(void)
{

//interrption INT0

}
 
// Adresse CGRAM de l'afficheur LCD
#define Add_Caract0_CGRAM 0x40             //caractre 0
#define Add_Caract1_CGRAM 0x48		   //caractre 1
#define Add_Caract2_CGRAM 0x50             //caractre 2
#define Add_Caract3_CGRAM 0x58             //caractre 3
#define Add_Caract4_CGRAM 0x60             //caractre 4
#define Add_Caract5_CGRAM 0x68             //caractre 5
#define Add_Caract6_CGRAM 0x70             //caractre 6
#define Add_Caract7_CGRAM 0x78             //caractre 7

// Adresses des Ports I2C
#define AD_BASE_PCF8574		0x40       // base I2C
#define AD_I2C_PORTA		0          // port A
#define AD_I2C_PORTB		1          // port B
#define AD_I2C_PORTC		2	   // port C
#define AD_I2C_PORTD		3          // port D

// Adresses des ports I2C
#define I2C_PORTA 0
#define I2C_PORTB 1
#define I2C_PORTC 2
#define I2C_PORTD 3

// Etat du graphe
#define etage_1	  0
#define	etage_2	  1
#define etage_3   2
#define monter	  3
#define descendre 4
#define erreur    5

// Prototype des fonctions :
void Rampe_accel(unsigned char);
void Rampe_decel(unsigned char);
void Ecrire_PCF8574(unsigned char add, unsigned char valeur);
void LED1_egal_1();
void LED1_egal_0();
void LED2_egal_1();
void LED2_egal_0();
void LED3_egal_1();
void LED3_egal_0();
void EL1_egal_1();
void EL1_egal_0();
void EL2_egal_1();
void EL2_egal_0();
void EL3_egal_1();
void EL3_egal_0();
void DEF_egal_1();
void DEF_egal_0();
void init_CGRAM(char valeur[8][8]);
unsigned char Lire_PCF8574(unsigned char add);

// Caractres personnaliss placs dans la mmoire CGRAM du LCD


// Caractre n1 : ATTENTION :
//---------------------------
const unsigned char attention[8][8] = {
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
{0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
{0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
{0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
{0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
{0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
{0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM                


void main(void)
{
/*--------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
--------------------------------------------------------------------------------------------------------------*/
unsigned char etat,OCR1AL,OCR1BL;
unsigned char PO1,PO2,PO3;
unsigned char PC1,PC2,PC3;
unsigned char AP1,AP2,AP3;
unsigned char AC1,AC2,AC3;
unsigned char VP1,VP2,VP3;
unsigned char coef;
unsigned char EtatPORTA,EtatPORTB,EtatPORTC,EtatPORTD;        


// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xA1;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;

// I2C Bus initialisation
i2c_init();

// LCD module initialisation
lcd_init(20);        

// Global enable interrupts
#asm("sei")

// initialisation :
//----------------

{
sprintf(display_buffer_ligne0,"   PPE ascenseur");
sprintf(display_buffer_ligne1,"    2006 / 2007");
sprintf(display_buffer_ligne2,"     Carte SSI");
sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
//Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
delay_ms(4000);

//faire descendre la cabine jusqu' l'tage 1 et faire clignoter les leds et afficher..

while (PC1==0)                         
  {
  sprintf(display_buffer_ligne0,"   Initialisation");
  sprintf(display_buffer_ligne1,"        ----");
  sprintf(display_buffer_ligne2," dplacement de la");
  sprintf(display_buffer_ligne3,"cabine jusqu'au RDC");
  //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
  //OCR1AL=;              //  complter : lancer le moteur en descente
  //OCR1BL=;              //  complter : lancer le moteur en descente
  LED1_egal_1();
  LED2_egal_1();
  LED3_egal_1();
  DEF_egal_1();
  delay_ms(500);
  LED1_egal_0();
  LED2_egal_0();
  LED3_egal_0();
  DEF_egal_0();
  }
OCR1AL=0;                // arrter le moteur
OCR1BL=0;                // arrter le moteur
etat=etage_1;
}

//fin initialisation

while (1)
      {
      switch (etat)
      {
      case etage_1 : EL1_egal_1();
                     LED1_egal_1();
                     sprintf(display_buffer_ligne0,"Etage 1");
                     sprintf(display_buffer_ligne1,"");
                     sprintf(display_buffer_ligne2,"attente appel");
                     sprintf(display_buffer_ligne3,"porte 1 deverouillee");
                     //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
               if ((AP2 == 1)||(AC2 == 1))
       	       	 {
       	  	   do           //crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"tage 2 demand");
       	  	   sprintf(display_buffer_ligne1,"");       
                   sprintf(display_buffer_ligne2,"fermer la porte !!");
                   sprintf(display_buffer_ligne3,"");
       	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                   coef=1; 
                   }
                   while(PO1==1);
                   etat=monter; 
                 } 
                    
       	       	else if  ((AP3 == 1)||(AC3 == 1))
       	       	 {
       	  	   do           //crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"tage 3 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !!");
       	           sprintf(display_buffer_ligne3,"");
       	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                   coef=2;
                   }
       	           while(PO1==1);
       	           etat=monter;
                 }
                else etat=etage_1;
                LED1_egal_0();
      break;
      
      case etage_2 :  EL2_egal_1();
                      LED2_egal_1();
                      sprintf(display_buffer_ligne0,"Etage 2");
                      sprintf(display_buffer_ligne1,"");
                      sprintf(display_buffer_ligne2,"attente appel");
                      sprintf(display_buffer_ligne3,"porte 2 deverouillee");
                      //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP1 == 1)||(AC1 == 1))
                 {
       	  	   do           //crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           sprintf(display_buffer_ligne3,"");
       	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                   coef=1; 
                   }
                   while(PO2==1); 
                   etat=descendre;
                 }
       	       	else if  ((AP3 == 1)||(AC3 == 1))
       	       	 {
       	  	   do           //crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           sprintf(display_buffer_ligne3,"");
       	           //Affiche_LCD1(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                   coef=1;
                   }   
                   while(PO2==1);
                   etat=monter;
                 }
       	       	else etat=etage_2;
       	       	LED2_egal_0();
      break; 
      
      case etage_3 :  EL3_egal_1();
                      LED3_egal_1();
                      sprintf(display_buffer_ligne0,"etage 3");
                      sprintf(display_buffer_ligne1,"");
                      sprintf(display_buffer_ligne2,"attente appel");
                      sprintf(display_buffer_ligne3,"porte 3 deverouillee");
                      //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP1 == 1)||(AC1 == 1))
                 {
       	  	   do           //crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           sprintf(display_buffer_ligne3,"");
       	           //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                   coef=2; 
                   }
                   while(PO3==1);
                   etat=descendre;
                 }
       	       	else if  ((AP2 == 1)||(AC2 == 1))
       	       	 {
       	  	   do           //crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 2 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           sprintf(display_buffer_ligne3,"");
       	           //Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                   coef=1;
                   }
       	           while(PO3==1);
                   etat=descendre;
                 }
                 else etat=etage_3;
                 LED3_egal_0();
      break; 
      
      case monter : OCR1AL=0  ;      //  complter (moteur  l'arrt)
                    OCR1BL=0  ;      //  complter
                     while ((PO1==0)||(PO2==0)||(PO3==0));
                     if ((VP1==1)&&(VP2==1)&&(VP3==1))                            
                      {
                      Rampe_accel(0);
                      delay_ms(coef*500);
                      Rampe_decel(0);
                      }
                     else
                      etat=erreur;
                     while ((PC2==0)||(PC3==0));
                      OCR1AL=0  ;      //  complter (moteur  l'arrt)
                      OCR1BL=0  ;      //  complter
                     if (PC2==1)                        
                      etat=etage_2;
                     else if (PC3==1)                        
                      etat=etage_3;
                     else
                      etat=erreur;
      break; 
      	
      case descendre : OCR1AL=0  ;      //  complter (moteur  l'arrt)
                       OCR1BL=0  ;      //  complter
                        while ((PO1==0)||(PO2==0)||(PO3==0));
                        if ((VP1==1)&&(VP2==1)&&(VP3==1))                            
                         {
                         Rampe_accel(1);
                         delay_ms(coef*500);
                         Rampe_decel(1);
                         }
                        else
                         etat=erreur;
                        while ((PC2==0)||(PC1==0));
                        OCR1AL=0  ;      //  complter (arrter le moteur)
                        OCR1BL=0  ;      //  complter
                        if (PC2==1)                        
                         etat=etage_2;
                        else if (PC1==1)                        
                         etat=etage_1;
                        else
                         etat=erreur;
      break;
      
      case erreur : DEF_egal_1();
                    init_CGRAM(attention);
                    lcd_gotoxy(17,0);		// caractre perso (ATTENTION) ligne 0
		    lcd_putchar(0);
		    lcd_gotoxy(18,0);
		    lcd_putchar(1);
		    lcd_gotoxy(17,1);           // caractre perso (ATTENTION) ligne 1
		    lcd_putchar(2);
		    lcd_gotoxy(18,1);
		    lcd_putchar(3);
		    lcd_gotoxy(16,2);           // caractre perso (ATTENTION) ligne 2
		    lcd_putchar(4);
		    lcd_gotoxy(17,2);
		    lcd_putchar(5);
		    lcd_gotoxy(18,2);
		    lcd_putchar(6);
		    lcd_gotoxy(19,2);
		    lcd_putchar(7);
      break;
   }
  };

AP1 = (Lire_PCF8574(I2C_PORTA)&0b01000000);        // lecture PA6
AP2 = (Lire_PCF8574(I2C_PORTA)&0b10000000);        // lecture PA7
AP3 = (Lire_PCF8574(I2C_PORTB)&0b00000001);        // lecture PB0
AC1 = (Lire_PCF8574(I2C_PORTB)&0b00000010);        // lecture PB1
AC2 = (Lire_PCF8574(I2C_PORTB)&0b00000100);        // lecture PB2
AC3 = (Lire_PCF8574(I2C_PORTB)&0b00001000);        // lecture PB3
PO1 = (Lire_PCF8574(I2C_PORTA)&0b00001000);        // lecture PA3
PO2 = (Lire_PCF8574(I2C_PORTA)&0b00010000);        // lecture PA4
PO3 = (Lire_PCF8574(I2C_PORTA)&0b00100000);        // lecture PA5
VP1 = (Lire_PCF8574(I2C_PORTC)&0b00000001);        // lecture PC0
VP2 = (Lire_PCF8574(I2C_PORTC)&0b00000010);        // lecture PC1
VP3 = (Lire_PCF8574(I2C_PORTC)&0b00000100);        // lecture PC2
PC1 = (Lire_PCF8574(I2C_PORTA)&0b00000001);        // lecture PA0
PC2 = (Lire_PCF8574(I2C_PORTA)&0b00000010);        // lecture PA1
PC3 = (Lire_PCF8574(I2C_PORTA)&0b00000100);        // lecture PA2


 

//ajouter la relecture de l'tat des sorties (EL1, EL2 et EL3) par scurit !!! addresses  revoir

EL1 = (Lire_PCF8574(I2C_PORTD)&0b00000000);        // lecture PDx
EL2 = (Lire_PCF8574(I2C_PORTD)&0b00000000);        // lecture PDx
EL3 = (Lire_PCF8574(I2C_PORTD)&0b00000000);        // lecture PDx




EtatPORTA = (Lire_PCF8574(I2C_PORTA));           // lecture du port A
EtatPORTB = (Lire_PCF8574(I2C_PORTB));           // Lecture du port B
EtatPORTC = (Lire_PCF8574(I2C_PORTC));           // Lecture du port C
EtatPORTD = (Lire_PCF8574(I2C_PORTD));           // Lecture du port D
                                        

Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
}

//fin du programme principal

// Sous-programmes
//----------------
    
unsigned char Lire_PCF8574(unsigned char add)          // Procdure de lecture du port I2C
{
  unsigned char entrees;
  i2c_start();
  i2c_write(0x41 | add << 1);
  entrees = i2c_read(0);
  i2c_stop();
  return entrees;    
} 
