/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8a Evaluation
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 09/05/2007
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the AT90S8535


#pragma used+
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSR=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR=9;
sfrb UCR=0xa;
sfrb USR=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for I2C bus master functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <i2c.h>
*/


#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-


//*****************************************************************
// Livrairie SSI.h
// Auteur: Philippe MARIANO
// Cre le 10/3/03
// Dernire rvision le 6/2006
// Ce fichier est destin  un projet CVAVR utilisant la carte SSI
// Il doit tre plac dans le sous rpertoire \INC
// Composant cible : AT90S8535
//*****************************************************************




// -----------------------------------------------------
// Dfinition du code des BPs de la carte AT90S8535  SSI
//------------------------------------------------------


//-----------------------------------------
//Codes de commande de l'afficheur LCD 2x16
//-----------------------------------------

// Initialisation du dplacement du curseur
//-----------------------------------------


// Affichage           code       On/Off   curseur      clignotement 
//------------------------------------------------------------------

// Dplacement du curseur ou de l'affichage
 

// ************************************************************************
//
// Prototype des fonctions gnrales de la carte SSI 
// 
// ************************************************************************
// ----------------------- Rcapitulatif ----------------------- 
// unsigned char Lire_BP(void);
// void Affiche_LCD(char *ligne1,char *ligne2);
// unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);
// void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);
// void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);
// ************************************************************************

#pragma used+

unsigned char Lire_BP(void);
/*
Rle : Lit l'tat des BP de la carte ATMEL S_SI(PortA) 

Commentaires : La fonction renvoie le code de la touche actionne lors du premier
appel (INC = 0x1F, DEC = Ox2f, OK = 0x37, ECHAP = 0x3B, SET = 0x3D, ENTR=0x3E)
puis 0x00 si la touche est maintenue ou 0xFF si la touche est relche. 

Entres : aucunes 

sortie : code de la touche ou 0x00 ou 0xFF
*/


void Affiche_LCD(char *ligne1,char *ligne2);
/*
Rle : Gre l'affichage d'un LCD quip d'un contrleur Hitachi
       et command en mode 4 bits

Commentaires : Envoie le contenu de deux tableaux de 16 caractres sur les ligne 1 et
2 d'un afficheur LCD 2*16 caractres.
Chaque tableau doit pouvoir contenir les 16 caractres  afficher + \0

Librairie utilis : lcd.h  

Entres : ligne1, ligne2 = tableaux de 17 caractres

Sorties : Aucune
*/     
void Affiche_LCD440(char *ligne1,char *ligne2,char *ligne3, char *ligne4);

unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);
/*
Rle : Lit un octet dans une mmoire srie gre par le protocole I2C
Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier     
      
Sortie : contenu de l'adresse adressmap du botier situ en addcase
*/


void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);
/*
Rle : Ecrit un octet dans une mmoire srie gre par le protocole I2C

Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h et delay.h

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier
      data : octet  crire  la position adressmap du botier situ en addcase
      
Sorties : aucune

*/


void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);
/*
Rle : Lit 32 octets dans une mmoire srie gre par le protocole I2C

Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h 

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier          
      
Sorties : contenu des 32 adresses  partir de adressmap du botier situ en addcase
*/


int regle_HTR(unsigned char adresse,unsigned char Heure_ou_Date, char H_J, char mn_mois, int sec_annee);
// -------------------------------
// Etats du graphe reglage
// ------------------------------- 

/*                                

Rle : Rgle la date et l'heure d'une HTR PCF8583 situe  adresse (0 ou 1) 

Commentaires : La fonction permet  l'utilisateur d'effectuer le rglage de l'heure si Heure_ou_Date = 0
ou de la date si Heure_ou_Date = 1.Les paramtres H_J, mn_mois, sec_annee servent de base
aux rglages. Celui-ci s'effectue avec les BP :
INC pour augmenter une valeur,
DEC pour diminuer une valeur,
OK  pour valider la valeur modifie et passer au rglage suivant
EChap pour transfrer la valeur rgle et sortir de la fonction

Librairie utilise : PCF8583.h

Entres :
	adresse : adresse du boitier (0 ou 1 selon A0) 
	Si Heure_ou_Date = 0 (rglage de l'heure) alors -1 < H_J < 24, -1 < mn_mois < 60
							-1 < sec_annee < 60 
						  sinon -1 < H_J < 32, 0 < mn_mois < 13
							1999 < sec_annee < 2050  
Sortie : la fonction renvoie 0 
*/ 


// ************************************************************************
//
// Prototype des fonctions diverses 
// 
// ************************************************************************
// ----------------------- Rcapitulatif ----------------------- 
// unsigned char D2000_read(unsigned char adressmap);
// void D2000_write(unsigned char adressmap, unsigned char data);
// ***********************************************************************


unsigned char D2000_read(unsigned char adressmap);
/* Rle : Lit un octet dans une carte  puce D2000 (gre par le protocole I2C)

Commentaires : Mmoire eeprom de type PCF8582 (256 octets)
               Adresse du botier fige en 0xa0 
               
Librairie utilise : I2C.h

Entres : adressmap = adresse  atteindre dans le botier

Sorties : contenu de l'adresse adressmap du botier situ en 0xa0
*/
 

void D2000_write(unsigned char adressmap, unsigned char data);
/* Rle : Ecrit un octet dans une carte  puce D2000 (gre par le protocole I2C)

Commentaires : Mmoire eeprom de type PCF8582 (256 octets)
               Adresse du botier fige en 0xa0 
               
Librairie utilise : I2C.h
                
Entres : 
          adressmap = adresse  atteindre dans le botier
          data = caractre  crire
          
Sorties : aucunes
*/


// ************************************************************************
//
// Prototype des fonctions destines  la simulation des systmes du labo 
// 
// ************************************************************************

// ----------------------- Rcapitulatif -----------------------
// Fonction dveloppes pour les TP Pousse seringue
//-------------------------------------------------------------------------    

// int Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);
// unsigned char Select_Seringue(void);
// ************************************************************************


int Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);
/*
Rle : Renvoie la valeur de la consigne de dbit rgle sous la forme dizaine, unit, dizime

Commentaires : fonction crite pour le pousse seringue

Librairie utilise : lcd.h et stdio.h

Entres / sortie : dizaine de ml/h, unit ml/h, dizime ml/h
*/
 

unsigned char Menu_Select_Seringue(void);
/*Rle : Renvoie le type de seringue slectionne
	 0 : TERUMO 50CC	1 : MONOJECT/ BD 50CC	2 : BD 20CC

Commentaires : fonction crite pour le pousse seringue

Librairie utilise : lcd.h et stdio.h 

sortie : seringue slectionne 
*/

#pragma used-

#pragma library ssi.lib

/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib


// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);


char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib



char display_buffer_ligne0[20]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[20]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[20]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[20]; 	   // tampon ligne 3 de l'afficheur

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm

// Afficheur LCD
#asm
   .equ __lcd_port=0x15
#endasm

// Adresses des Ports I2C

// Adresses des ports I2C

// Prototype des fonctions
//-------------------------
unsigned char Lire_PCF8574(unsigned char add);

void main(void)
{
// Declare your local variables here
unsigned char I;
unsigned char PC1,PC2,PC3;
unsigned char AC1,AC2,AC3;
                   
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x01;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x01;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x30;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 500,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Inverted
// OC1B output: Inverted
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xF1;
TCCR1B=0x02;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// I2C Bus initialisation
i2c_init();

// LCD module initialisation
lcd_init(20);

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;




while (1)
  {
      PC1 = (Lire_PCF8574(0)&0b00000001);        // lecture PA0
      PC2 = (Lire_PCF8574(0)&0b00000010);        // lecture PA1
      PC3 = (Lire_PCF8574(0)&0b00000100);        // lecture PA2
      AC1 = (Lire_PCF8574(1)&0b00000010);        // lecture PB1
      AC2 = (Lire_PCF8574(1)&0b00000100);        // lecture PB2
      AC3 = (Lire_PCF8574(1)&0b00001000);        // lecture PB3
      
      sprintf(display_buffer_ligne0,"Programme ascenseur");
      sprintf(display_buffer_ligne1,"  initialisation");
      sprintf(display_buffer_ligne2,"--------------------");
      sprintf(display_buffer_ligne3,"     prog test");
      Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
      
      if (PINA.5==0)   // Montee
      { 
      	for(I=20;I<250;I=I+10)
      	{
      	PORTB.0 = 1;
      	delay_ms(200);
      	OCR1AL=I;
      	OCR1BL=0;
      	}              
      	
        delay_ms(2000);        
        
        for(I=250;I>20;I=I-10)
      	{
      	PORTB.0 = 1;
      	delay_ms(200);
      	OCR1AL=I;
      	OCR1BL=0;
      	}	 
      }
      
      else PORTB.0=0;  
      
      if (PINA.4==0)	// Descendre  
      { 
      	for(I=20;I<250;I=I+10)
      	{             
      	PORTB.0 = 1;
      	delay_ms(200);
        OCR1AL=0;
        OCR1BL=I;
  	}
        
        delay_ms(2000);
        
        for(I=250;I>20;I=I-10)
      	{
      	PORTB.0 = 1;
      	delay_ms(200);
      	OCR1AL=0;
      	OCR1BL=I;
      	}	 
      }
      
      else PORTB.0=0;	// Place your code here 
            
  };
}

unsigned char Lire_PCF8574(unsigned char add)
{
  unsigned char entrees;
  i2c_start();
  i2c_write(0x41 | add << 1);
  entrees = i2c_read(0);
  i2c_stop();
  return entrees;    
}
