/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : ES I2C
Version : 1
Date    : 29/11/2006
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: Test de la carte ES I2C


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>
#include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD
#include <delay.h>    // contient la fonction delay_ms
#include <stdio.h>    // contient la fonction sprintf

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

// Adresses des Ports I2C
#define AD_BASE_PCF8574		0x40
#define AD_I2C_PORTA		0
#define AD_I2C_PORTB		1
#define AD_I2C_PORTC		2
#define AD_I2C_PORTD		3

// Declare your global variables here
/*-----------------------------------------------------------------------------------------
type 		nom 				       		dsignation       
------------------------------------------------------------------------------------------*/
char display_buffer_ligne0[21]; 			// tampon ligne 0 de l'afficheur
char display_buffer_ligne1[21]; 	       		// tampon ligne 1 de l'afficheur
char display_buffer_ligne2[21]; 			// tampon ligne 2 de l'afficheur
char display_buffer_ligne3[21]; 	       		// tampon ligne 3 de l'afficheur
enum Etat_Test {LECTURE_I2C_PORTA,LECTURE_I2C_PORTB,LECTURE_I2C_PORTC, ECRITURE_I2C_PORTD,
 SAISIE_VALEUR, ENVOI_VALEUR} etat=LECTURE_I2C_PORTA, etat_1=LECTURE_I2C_PORTB;                 // Etats du graphe tests

// Constantes
const char MENU_E[]="INC>Suiv DEC>PRE"; 


// Prototype des fonctions
//-------------------------
unsigned char Lire_PCF8574(unsigned char add);
unsigned char Ecrire_valeur(unsigned char x, unsigned char y);
void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD);
//-----------------------
// Programme principal
//-----------------------

void main(void)
{   // dbut prog
// Declare your local variables here
// -----------------------------------------------------------------------------------------
//type 		nom 					Commentaires  
// -------------------------------------------------------------------------------------- --
unsigned char entrees_A=0, entrees_1_A = 1;	// reoit l'tat du PORT A sur l'I2C
unsigned char entrees_B=0, entrees_1_B = 1;	// reoit l'tat du PORT B sur l'I2C
unsigned char entrees_C=0, entrees_1_C = 1;	// reoit l'tat du PORT C sur l'I2C
unsigned char valeur_portD=0;			// contient la valeur  envoyer sur le PORT D
unsigned char BP;                               // contient le code du BP appuy (voir SSI.h)

PORTA=0x3F;
DDRA=0x00;

PORTB=0x00;
DDRB=0x3F;

// I2C Bus initialization
i2c_init();

// LCD module initialization
lcd_init(20);


sprintf(display_buffer_ligne0,"Test de la carte");
sprintf(display_buffer_ligne1,"****E_S_I2C*****");
sprintf(display_buffer_ligne2,"Test de la carte");
sprintf(display_buffer_ligne3,"****E_S_I2C*****");
Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
delay_ms(3000);


while (1)
      {		   // Dbut While(1)  
       
      BP = Lire_BP();
      entrees_A = Lire_PCF8574(0);
      entrees_B = Lire_PCF8574(1);
      entrees_C = Lire_PCF8574(2);
      
      switch (etat)
       {               // Dbut switch (etat)
        case LECTURE_I2C_PORTA :   if ((etat_1 != etat) || (entrees_A != entrees_1_A))
                        { 
                         sprintf(display_buffer_ligne0,"[E] PORTA = 0x%-x",entrees_A);
                         sprintf(display_buffer_ligne1,MENU_E);
                         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
                         entrees_1_A = entrees_A;
                        } 
        		if (BP == INC) etat = LECTURE_I2C_PORTB;
       		       	       	else if (BP==DEC) etat = ECRITURE_I2C_PORTD;
       			       			else etat = LECTURE_I2C_PORTA;
       			etat_1 = LECTURE_I2C_PORTA; 
       		        
        break;
        
        case LECTURE_I2C_PORTB :   if ((etat_1 != etat) || (entrees_B != entrees_1_B))
                        { 
                         sprintf(display_buffer_ligne0,"[E] PORTB = 0x%-x",entrees_B);
                         sprintf(display_buffer_ligne1,MENU_E);
                         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
                         entrees_1_B = entrees_B;
                        } 
        		if (BP == INC) etat = LECTURE_I2C_PORTC;
       		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTA;
       			       			else etat = LECTURE_I2C_PORTB;
       			etat_1 = LECTURE_I2C_PORTB; 
       		        
        break;
        
        case LECTURE_I2C_PORTC :   if ((etat_1 != etat) || (entrees_C != entrees_1_C))
                        { 
                         sprintf(display_buffer_ligne0,"[E] PORTC = 0x%-x",entrees_C);
                         sprintf(display_buffer_ligne1,MENU_E);
                         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
                         entrees_1_C = entrees_C;
                        } 
        		if (BP == INC) etat = ECRITURE_I2C_PORTD;
       		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTB;
       			       			else etat = LECTURE_I2C_PORTC;
       			etat_1 = LECTURE_I2C_PORTC; 
       		        
        break; 
        
        case ECRITURE_I2C_PORTD :   if (etat_1 != etat) 
                        { 
                         sprintf(display_buffer_ligne0,"[S]Val=%-x OK>rgl",valeur_portD);
                         sprintf(display_buffer_ligne1,"SET>envoi val.  ");
                         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
                         }
        		if (BP == INC) etat = LECTURE_I2C_PORTA;
       		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTC;
       		       	       	                   else if (BP==OK) etat = SAISIE_VALEUR;
       		       	       	                   		else if (BP==SET) etat = ENVOI_VALEUR;
       			       						else etat = ECRITURE_I2C_PORTD;
       			etat_1 = ECRITURE_I2C_PORTD; 
       			
       		        
        break; 
       
        case SAISIE_VALEUR :   
                         sprintf(display_buffer_ligne0,"0x%-u  INC>+ DEC>-",valeur_portD);
                         sprintf(display_buffer_ligne1,"OK>suiv ENTR>srt"); 
                         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                         valeur_portD = Ecrire_valeur(2,0); 
                         etat_1 = SAISIE_VALEUR;
                         etat = ECRITURE_I2C_PORTD;
        break;
        
        case ENVOI_VALEUR : if (etat_1 != etat)
        		{  
                         sprintf(display_buffer_ligne0,"[S] PORTD = 0x%-x",valeur_portD);
                         sprintf(display_buffer_ligne1,"OK>rgl INC DEC");
                         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                         Ecrire_PCF8574(AD_I2C_PORTD,valeur_portD);  
          		}
                         if (BP == INC) etat = LECTURE_I2C_PORTA;
       		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTC;
       		       	       	                   else if (BP==OK) etat = ECRITURE_I2C_PORTD; 
       		       	       	                   		else etat = ENVOI_VALEUR;
       			 etat_1 = ENVOI_VALEUR;
        break;
        
        } //fin du switch
      } // fin du while
} // fin prog

unsigned char Lire_PCF8574(unsigned char add)
{
  unsigned char entrees;
  i2c_start();
  i2c_write(0x41 | add << 1);
  entrees = i2c_read(0);
  i2c_stop();
  return entrees;    
} 

void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD)
{
  i2c_start();
  i2c_write(0x40 | add << 1);
  i2c_write(valeur_portD);
  i2c_stop();
  delay_ms(10);
}

unsigned char Ecrire_valeur(unsigned char x, unsigned char y)
{    
 unsigned char BP, etat=0, etat_1=1; 
 int dizaines=0, dizaines_1 = 1, unites = 0, unites_1 = 1;
 unsigned char Table_aff[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
 
 _lcd_write_data(displayOff3);
 
 while(1)
  {
   BP = Lire_BP();
   switch (etat)
	{
	  case 0 : // Rglage des dizaines
                   if (dizaines==-1) dizaines = 15;
        		else if (dizaines == 16) dizaines = 0;
        		
   		   if ((dizaines_1 != dizaines) || (etat_1 != etat))
        		{
        		  lcd_gotoxy(x,y);
        	          lcd_putchar(Table_aff[dizaines]);
        	          dizaines_1 = dizaines;
        	   	}
        	   switch(BP)
        	   	{
        	    	  case INC   : dizaines = dizaines + 1; break;
        	    	  case DEC   : dizaines = dizaines - 1; break;
        	    	  case OK    : etat = 1; break;
        	   	  case ENTR  : etat = 2; break;
        	    	  default    : etat = 0;
        	    	}
        	    	  etat_1 = 0; 	   
	  break;
	  
	  case 1 : // Rglage des unites
                   if (unites==-1) unites = 15;
        		else if (unites == 16) unites = 0;  
        		
   		   if ((unites_1 != unites) || (etat_1 != etat))
        		{
                          lcd_gotoxy(x+1,y);
        	          lcd_putchar(Table_aff[unites]);
        	          unites_1 = unites;
        	   	}
        	   switch(BP)
        	   	{
        	    	  case INC   : unites = unites + 1; break;
        	    	  case DEC   : unites = unites - 1; break;
        	    	  case OK    : etat = 0; break;
        	   	  case ENTR  : etat = 2; break;
        	    	  default    : etat = 1;
        	    	}
        	    	  etat_1 = 1; 
	  break;
	  
	  case 2 : _lcd_write_data(displayOn0);
	  	   return (unsigned char)(16*dizaines + unites);
	  break;
	  
	}
   }
}

 